;These are offsets from the start adress of a window structure. Use
;with caution!

W_TI_FLAGS		EQU	$00
W_FONT			EQU	$02
W_TEXT_LINE_ATTRIBUTES	EQU	$03
W_BACKGROUND_ATTRIBUTES	EQU	$04
W_BLANK			EQU	$05
W_OWNER			EQU	$06
W_CUR_X			EQU	$08
W_CUR_Y			EQU	$0A
W_CURSOR_X		EQU	$0C
W_CURSOR_Y		EQU	$0E
W_CLIENT_REGION_X1	EQU	$10
W_CLIENT_REGION_Y1	EQU	$11
W_CLIENT_REGION_X2	EQU	$12
W_CLIENT_REGION_Y2	EQU	$13
W_X_POS			EQU	$14
W_Y_POS			EQU	$16
W_CLIP_REGION_X1	EQU	$18
W_LEFT_CLIP		EQU	W_CLIP_REGION_X1
W_CLIP_REGION_Y1	EQU	$19
W_TOP_CLIP		EQU	W_CLIP_REGION_Y1
W_CLIP_REGION_X2	EQU	$1A
W_RIGHT_CLIP		EQU	W_CLIP_REGION_X2
W_CLIP_REGION_Y2	EQU	$1B
W_BOTTOM_CLIP		EQU	W_CLIP_REGION_Y2
W_WIDTH			EQU	$1C
W_HEIGHT		EQU	$1E
W_CONTENTS_HANDLE	EQU	$20
;WINDOW "HEADER" FOR THE WINDOW LIST
W_HEADER		EQU	$22
W_NEXT			EQU	W_HEADER
W_ID			EQU	W_HEADER+4
W_PRIORITY		EQU	W_HEADER+6
W_FLAGS			EQU	W_HEADER+7
;TIOS STRUCTURE ENDS HERE
W_WIDTH_IN_WORDS	EQU	$30
W_STRUCTURE		EQU	$32
;HIDDEN DATA
W_HD			EQU	$36
W_DATARETURN		EQU	W_HD	;Adress to window datareturn area
W_SHIFTED_HANDLE	EQU	W_HD+4	;Handle of gfx to plot
W_MASK_HANDLE		EQU	W_HD+6	;Handle of refresh mask
;FOR SHIFTING
W_SH			EQU	W_HD+8	;$3E
W_Y_OFFSET_IN_CONTENTS	EQU	W_SH	;Offset within contents
W_VISIBLE_ROWS		EQU	W_SH+2	;How many columns to shift per row
W_VISIBLE_COLUMNS	EQU	W_SH+4	;How many rows to shift
W_ROWADD_CONTENTS	EQU	W_SH+6	;RowAdd for contents/mask
W_ROWADD_LCD		EQU	W_SH+8	;RowAdd for the LCD
W_SHIFT_AMOUNT		EQU	W_SH+10	;How much to shift each word
W_LCD_START_OFFSET	EQU	W_SH+12	;Where to start plotting on the LCD
W_X_OFFSET_IN_CONTENTS	EQU	W_SH+14	;Offset within mask
W_SHIFTED_WIDTH		EQU	W_SH+16
W_HEADER_SIZE		EQU	W_SH+18

WF_LOCKED		EQU	%00000010
WFB_LOCKED		EQU	1

W_DR_KEY		EQU	0
W_DR_MOUSE_WINDOW	EQU	W_DR_KEY+2
W_DR_MOUSE_BUTTON	EQU	W_DR_MOUSE_WINDOW+2
W_DR_MOUSE_X		EQU	W_DR_MOUSE_BUTTON+2
W_DR_MOUSE_Y		EQU	W_DR_MOUSE_X+2

;Key being held down
;Mousebutton being held down
;Object being used
;Object being pressed

L_BLACK		EQU	2
L_WHITE		EQU	0
L_USES_PATTERN	EQU	1

; Flags: 0 = Nothing
;        1 = Pattern
;        2 = White
;        3 = Black



;IDEA: All X/Y and Width/Height coords proportional, i.e.:
;      Real X = (Window width * Data X) / 256
;Possibly one flag per X/Y/Width/Height is required to indicate this...

;General object flags
;X_ABS			EQU	%00000000
;X_REL			EQU	%10000000
;Y_ABS			EQU	%00000000
;Y_REL			EQU	%01000000
;W_ABS			EQU	%00000000
;W_REL			EQU	%00100000
;H_ABS			EQU	%00000000
;H_REL			EQU	%00010000
;USES_AREA		EQU	%00001000 (no area <=> entire window)

;Placement flags (4 bits)
PL_LEFT_TOP		EQU	%0000000000000000
PL_RIGHT_TOP		EQU	%0001000000000000
PL_CENTER_TOP		EQU	%0010000000000000
PL_CENTER_BOTTOM	EQU	%0110000000000000
PL_LEFT_BOTTOM		EQU	%0100000000000000
PL_RIGHT_BOTTOM		EQU	%0101000000000000
PL_LEFT_CENTER		EQU	%1000000000000000
PL_RIGHT_CENTER		EQU	%1001000000000000
PL_CENTERED		EQU	%1010000000000000

;Button-specific flags (5 bits)
BU_EMPTY		EQU	%0000000000000000
BU_TEXT			EQU	%0000100000000000
BU_GFX			EQU	%0000010000000000

BU_NOFILL		EQU	%0000000000000000
BU_FILLED_BLACK		EQU	%0000001000000000
BU_FILLED_WHITE		EQU	%0000001100000000
BU_NOFRAME		EQU	%0000000000000000
BU_FRAMED_BLACK		EQU	%0000000010000000
BU_FRAMED_WHITE		EQU	%0000000011000000
BU_FLAT			EQU	%0000000000000000
BU_3D			EQU	%0000000000100000


;Bit 9 = frame/noframe with color = ~bit 7
;Bit 8 = fill/nofill with color = bit 7
;Bit 7 = color if fill and/or frame, "raised filled white" if no fill or frame

;Text font & style flags (8 bits)
;Style uses A_NORMAL etc...:    %0000000000000xxx
;Fonts
BU_SMALL_FONT		EQU	%0000000000000000
BU_LARGE_FONT		EQU	%0000000000001000
BU_HUGE_FONT		EQU	%0000000000010000

EMPTY_BUTTON		EQU	BU_EMPTY+BU_FILLED_WHITE+BU_FRAMED_BLACK+BU_3D
SMALL_TEXT_BUTTON	EQU	PL_CENTERED+BU_TEXT+BU_FILLED_WHITE+BU_FRAMED_BLACK+BU_3D+BU_SMALL_FONT+A_NORMAL
LARGE_TEXT_BUTTON	EQU	PL_CENTERED+BU_TEXT+BU_FILLED_WHITE+BU_FRAMED_BLACK+BU_3D+BU_LARGE_FONT+A_NORMAL

;Box line flags
B_TOP_WHITE		EQU	%0000000000000010
B_TOP_BLACK		EQU	%0000000000000011
B_TOP_PATTERN		EQU	%0000000000000001
B_BOTTOM_WHITE		EQU	%0000000000001000
B_BOTTOM_BLACK		EQU	%0000000000001100
B_BOTTOM_PATTERN	EQU	%0000000000000100
B_LEFT_WHITE		EQU	%0000000000100000
B_LEFT_BLACK		EQU	%0000000000110000
B_LEFT_PATTERN		EQU	%0000000000010000
B_RIGHT_WHITE		EQU	%0000000010000000
B_RIGHT_BLACK		EQU	%0000000011000000
B_RIGHT_PATTERN		EQU	%0000000001000000
B_FRAMED_BLACK	EQU	B_TOP_BLACK+B_BOTTOM_BLACK+B_LEFT_BLACK+B_RIGHT_BLACK
B_FRAMED_WHITE	EQU	B_TOP_WHITE+B_BOTTOM_WHITE+B_LEFT_WHITE+B_RIGHT_WHITE
;BB_TOP_WHITE		EQU	%00000010
;BB_TOP_BLACK		EQU	%00000011
;BB_TOP_PATTERN		EQU	%00000001
;BB_BOTTOM_WHITE		EQU	%00001000
;BB_BOTTOM_BLACK		EQU	%00001100
;BB_BOTTOM_PATTERN	EQU	%00000100
;BB_LEFT_WHITE		EQU	%00100000
;BB_LEFT_BLACK		EQU	%00110000
;BB_LEFT_PATTERN		EQU	%00010000
;BB_RIGHT_WHITE		EQU	%10000000
;BB_RIGHT_BLACK		EQU	%11000000
;BB_RIGHT_PATTERN	EQU	%01000000
;BB_FRAMED_BLACK	EQU	BB_TOP_BLACK+BB_BOTTOM_BLACK+BB_LEFT_BLACK+BB_RIGHT_BLACK
;BB_FRAMED_WHITE	EQU	BB_TOP_WHITE+BB_BOTTOM_WHITE+BB_LEFT_WHITE+BB_RIGHT_WHITE

;Box fill flags
B_NOFILL		EQU	%0000000000000000
B_FILLED_WHITE		EQU	%0000001000000000
B_FILLED_BLACK		EQU	%0000001100000000
B_FILLED_PATTERN	EQU	%0000000100000000
;BB_NOFILL		EQU	%00000000
;BB_FILLED_WHITE		EQU	%00000010
;BB_FILLED_BLACK		EQU	%00000011
;BB_FILLED_PATTERN	EQU	%00000001

;GUI object types
R_AREA		EQU	0
R_BUTTON	EQU	1
R_HORIZ_SLIDER	EQU	2
R_VERT_SLIDER	EQU	3
R_TEXT		EQU	4
R_LINE		EQU	5
R_RECT		EQU	6
R_FILL		EQU	7
R_SETCLIP	EQU	8

;Return value add-on codes
RF_TRIG_FIRST	EQU	%1000000000000000
RF_USE_REPEAT	EQU	%0100000000000000
RF_TRIG_REPEAT	EQU	%0110000000000000
RF_TRIG_RELEASE	EQU	%0001000000000000
RF_QUIT		EQU	%0000100000000000

;***************************
;*                         *
;* WINDOW SYSTEM FUNCTIONS *
;*                         *
;***************************

;---------------------------------------------------------------------
; Init_Window_System(void)
;
; Function: Initialize Window system
;---------------------------------------------------------------------
winlib::Init_Window_System	equ	winlib@0000

;---------------------------------------------------------------------
; Load_Background_Image(WORD filehandle)
;
; Function: Load a background image. The current image will be
;  replaced. If filehandle=0 the image will be blank.
;---------------------------------------------------------------------
winlib::Load_Background_Image	equ	winlib@0001

;---------------------------------------------------------------------
; Close_Window_System(void)
;
; Function: Close and de-allocate all remaining windows.
;---------------------------------------------------------------------
winlib::Close_Window_System	equ	winlib@0002

;---------------------------------------------------------------------
;WORD: MouseX
;Current mouse X coordinate
;---------------------------------------------------------------------
winlib::MouseX			equ	winlib@0003

;---------------------------------------------------------------------
;WORD: MouseY
;Current mouse Y coordinate
;---------------------------------------------------------------------
winlib::MouseY			equ	winlib@0004

;---------------------------------------------------------------------
; BOOL WinOpen(WINDOW *w, WIN_RECT *dimensions, WIN_RETURN *wr,
;  WIN_STRUCTLIST *s)
;
; Function: Open the window with fixed dimensions using the flags set
;  within <w>.
;
; Return: d0 = 0 if success, -1 if not enough memory.
;---------------------------------------------------------------------
winlib::WinOpen			equ	winlib@0005

;---------------------------------------------------------------------
; void WinClose(WINDOW *w)
;
; Function: Remove the window from the LCD.
;---------------------------------------------------------------------
winlib::WinClose		equ	winlib@0006

;---------------------------------------------------------------------
; void WinSelect(WINDOW *w)
;
; Function: Select the window for drawing.
;---------------------------------------------------------------------
winlib::WinSelect		equ	winlib@0007

;---------------------------------------------------------------------
; Move_Window(WORD ID, WORD xpos, WORD ypos)
;
; Function: Move the window to (xpos,ypos).
;---------------------------------------------------------------------
winlib::Move_Window		equ	winlib@0008

;---------------------------------------------------------------------
; Refresh_Window(WINDOW *w)
;
; Function: Update the window's contents on the LCD.
;---------------------------------------------------------------------
winlib::Refresh_Window		equ	winlib@0009

;---------------------------------------------------------------------
; Move_Window_To_Front(WORD ID)
;
; Function: Move the window to the front.
;---------------------------------------------------------------------
winlib::Move_Window_To_Front	equ	winlib@000A



;*****************************
;*                           *
;* WINDOW GRAPHICS FUNCTIONS *
;*                           *
;*****************************

;---------------------------------------------------------------------
; Clear(WORD ID)
;
; Function: Clear the window contents block.
;---------------------------------------------------------------------
winlib::Clear			equ	winlib@000C

;---------------------------------------------------------------------
; SetClip(WORD ID, BYTE *clip)
;
; Function: Set window <ID> to use the clip area <clip>.
;---------------------------------------------------------------------
winlib::SetClip			equ	winlib@000D

;---------------------------------------------------------------------
; VertLine(WORD ID, WORD x, WORD y1, WORD y2, WORD flags,
;  [WORD pattern])
;
; Function: Draw a line from (x,y1) to (x,y2).
;
; Flags: 0 = Nothing
;        1 = Pattern
;        2 = White
;        3 = Black
;---------------------------------------------------------------------
winlib::VertLine		equ	winlib@000E

;---------------------------------------------------------------------
; HorizLine(WORD ID, WORD y, WORD x1, WORD x2, WORD flags,
;  [WORD pattern])
;
; Function: Draw a line from (x1,y) to (x2,y).
;
; Flags: 0 = Nothing
;        1 = Pattern
;        2 = White
;        3 = Black
;---------------------------------------------------------------------
winlib::HorizLine		equ	winlib@000F

;---------------------------------------------------------------------
; Box(WORD ID, WORD x, WORD y, WORD width, WORD height,
;  WORD flags, [WORD pattern], [WORD pattern], [WORD pattern],
;  [WORD pattern], [BYTE *gfx, BYTE *mask]
;
; Function: Draw a <width,height>-sized box at (x, y).
;---------------------------------------------------------------------
winlib::Box			equ	winlib@0010

;---------------------------------------------------------------------
; PlotGFX(WORD ID, WORD x, WORD y, BYTE *gfx, BYTE *mask)
;
; Function: Plot <gfx> with mask <mask> at (x,y) in window <ID>, using
;  the window's current clip area. The format for gfx is described in
;  the docs.
;---------------------------------------------------------------------
winlib::PlotGFX			equ	winlib@0011

;---------------------------------------------------------------------
; DrawStructure(WINDOW *w, WIN_STRUCTLIST *list)
;
; Function: Draw an entire structure list into window.
;---------------------------------------------------------------------
winlib::DrawStructure		equ	winlib@0015

;---------------------------------------------------------------------
; DrawStructureItem(WINDOW *w, WIN_STRUCTITEM *item)
;
; Function: Draw the <item> part of the structure list from into
;  window.
;---------------------------------------------------------------------
winlib::DrawStructureItem	equ	winlib@0016

;---------------------------------------------------------------------
; DrawStructureObject(WINDOW *w, WIN_STRUCTOBJECT *object)
;
; Function: Draw <object> into window.
;
; Output: a0 = *next object
;---------------------------------------------------------------------
winlib::DrawStructureObject	equ	winlib@0017
