	include		"calc.h"

	include		"doorsos.h"
	include		"hexlib.h"
	include		"macros.h"
	include		"prosit.h"
	include		"winlib.h"
	include		"keycodes.h"

	xdef		_prosit
	xdef    	_main
	xdef		_exit
	xdef		_comment

WIN_X			EQU	5
WIN_W			EQU	95
WIN_H			EQU	15
WIN_Y			EQU	SCREEN_HEIGHT-15-WIN_H
GRAB			EQU	8
EXIT_W			EQU	18
EXIT_H			EQU	9
EXIT_X			EQU	95-EXIT_W-2-1
EXIT_Y			EQU	3

_prosit:
	HEADER_BEGIN
	DEFINE_PROSIT_VERSION	PROSIT_VERSION_STRING
	DEFINE_PROSIT_FILETYPE	PROSIT_FILETYPE_PROGRAM
	DEFINE_PROSIT_STACKSIZE	600
	DEFINE_PROSIT_EVENT	"moub",Event_Mousebutton
	DEFINE_PROSIT_EVENT	"quit",Event_Quit
	HEADER_END

_main:
	move.b		#0,Window+W_FLAGS
	move.b		#0,Window+W_PRIORITY
	pea		window1(pc)			;*Structure
	move.l		#Window_Datareturn,-(sp)	;*Return
	pea		winrect(pc)			;*Window dimensions
	move.l		#Window,-(sp)			;*Window
	jsr		winlib::WinOpen
	lea		16(sp),sp

\sleep	jsr		Prosit::Sleep
	bra.s		\sleep



Event_Mousebutton:
	movem.l		a0/d1,-(sp)

	move.w		MouseButton,d1
	cmp.w		#1,d1
	beq.s		\minus
	cmp.w		#2,d1
	beq.s		\plus
	bra		\done
\minus	jsr		_ROM_CALL_297
	bra		\done
\plus	jsr		_ROM_CALL_296

\done	movem.l		(sp)+,a0/d1
	rts


_exit:
Event_Quit:
	move.l		#Window,-(sp)
	jsr		winlib::WinClose
	move.w		Prosit::CurrentProcessID,(sp)
	jsr		Prosit::Process_Terminate

;***********************************************************************

	EVEN
;WINDOW #1 STRUCTURE
window1:
lwgui	dc.l	w1gui	;Window GUI list
lwgotf	dc.l	w1foc	;"Window got focus" list
lwlostf	dc.l	w1nofoc	;"Window lost focus" list

;GUI LIST - FIRST ELEMENT
w1gui	dc.l	w1gui	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank

;GUI MANAGEMENT PART
	dc.l	w1gfx
	dc.l	w1fgfx
	dc.w	-1
	dc.l	w1b1m
	dc.w	1+RF_TRIG_FIRST+RF_TRIG_REPEAT
	dc.l	w1b1p
	dc.w	2+RF_TRIG_FIRST+RF_TRIG_REPEAT
	dc.l	w1b2
	dc.w	0+RF_TRIG_RELEASE+RF_QUIT
	dc.l	0

;GUI GRAPHICAL PART
w1gfx	dc.b	R_RECT,0,0,0,WIN_W-1,WIN_H-1
	dc.w	A_NORMAL
w1b1m	dc.b	R_BUTTON,0,GRAB+2,2,GRAB+2+11-1,11+2-1
	dc.w	LARGE_TEXT_BUTTON
	dc.b	"-",0
w1s1	dc.b	R_BUTTON,0,GRAB+2+12,2+3,0,0
	dc.w	PL_LEFT_TOP+BU_TEXT+BU_NOFILL+BU_NOFRAME+A_NORMAL+BU_SMALL_FONT
	dc.b	"Contrast",0,0
w1b1p	dc.b	R_BUTTON,0,GRAB+2+12+31,2,GRAB+2+12+31+11-1,2+11-1
	dc.w	LARGE_TEXT_BUTTON
	dc.b	"+",0
w1b2	dc.b	R_BUTTON,0,EXIT_X,EXIT_Y,EXIT_X+EXIT_W-1,EXIT_Y+EXIT_H-1
	dc.w	SMALL_TEXT_BUTTON
	dc.b	"Exit",0,0
	dc.b	-1

	EVEN
;"GOT FOCUS" LIST - FIRST ELEMENT
w1foc	dc.l	w1foc	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank
;"GOT FOCUS" MANAGEMENT PART
	dc.l	w1fgfx
	dc.l	0
;"GOT FOCUS" GRAPHICAL PART
w1fgfx	dc.b	R_FILL,0,0,0,GRAB-1,WIN_H-1
	dc.w	A_NORMAL
	dc.b	-1

	EVEN
;"LOST FOCUS" LIST - FIRST ELEMENT
w1nofoc	dc.l	w1nofoc	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank
;"LOST FOCUS" MANAGEMENT PART
	dc.l	w1lfgfx
	dc.l	0
;"LOST FOCUS" GRAPHICAL PART
w1lfgfx	dc.b	R_FILL,0,1,1,GRAB-2,WIN_H-2
	dc.w	A_REVERSE
	dc.b	-1




winrect	dc.w	WIN_X,WIN_Y,WIN_X+WIN_W-1,WIN_Y+WIN_H-1


_comment
	dc.b	"Prosit: Contrast",0

	BSS
Window	ds.b	W_HEADER_SIZE

Window_Datareturn:
WKey		dc.w	0
MouseWindow	dc.w	0
MouseButton	dc.w	0
MouseX		dc.w	0
MouseY		dc.w	0
	CODE

	END
