#define TI92PLUS

#include <romcalls.h>
#include <prosit.h>
#include <winlib.h>
#include <wmlib.h>
#include <gmlib.h>



int _library;

void GM_Draw3DBox(PWINDOW *w, SCR_RECT *r, BYTE attr)
{
  int i;
  WIN_RECT box = {r->xy.x0, r->xy.y0, r->xy.x1, r->xy.y1}, line1 = box, line2 = box;

  line1.x1 = r->xy.x0;
  line2.y1 = r->xy.y0;

  w->Win.CurAttr = 1-attr;

  for(i=0 ; i<=1 ; i++) {
    w->Win.DupScr = w->ContentsHandle[i];
    WinRect(&w->Win, &box, attr);
    WinLine(&w->Win, &line1);
    WinLine(&w->Win, &line2);
  }
}

void *TextButton(PWINDOW *w, GMO_TEXTBUTTON *o, WORD action)
{
  WORD inside = A_REVERSE;

  switch(action) {
  case GMO_INITIALIZE:
    GM_Draw3DBox(w, &o->area, A_NORMAL);
    WinFont(&w->Win, 0);
    w->Win.CurAttr = A_NORMAL;
    w->Win.DupScr = w->ContentsHandle[0];
    WinStrXY(&w->Win, ((int)o->area.xy.x1 + (int)o->area.xy.x0 - DrawStrWidth(o->str, 0))/2,
                       ((int)o->area.xy.y1 + (int)o->area.xy.y0)/2 - 2, o->str);
    break;
  case GMO_CLICK:
    while(!MOUSEKEY) {
      if(MouseInside(w, &o->area) ^ inside) {
        GM_Draw3DBox(w, &o->area, inside);
        PWinRefresh(w);
        inside = A_NORMAL - inside;
      }
    }
    GM_Draw3DBox(w, &o->area, A_NORMAL);
    PWinRefresh(w);
    if(inside) {
      w->Datareturn->w = w;
      w->Datareturn->ButtonID = o->ID;
      TriggerEvent(w->Win.TaskId, GMO_CLICKED_EVENT);
    }
    break;
  }
}

// ******************************************************
struct {
  void (*function) (PWINDOW *w, void *o, WORD action);
  WORD datasize;
} GM_FUNCTIONS[1] = 
{{(void *)&TextButton, 12}};
// ******************************************************

void *GM_DrawStructureObject(PWINDOW *w, void *o)
{
  HANDLE OldPlane = w->Win.DupScr;
  BYTE OldAttrs = w->Win.CurAttr, OldFont = w->Win.CurFont;

  GM_FUNCTIONS[*((BYTE *)o) - 1].function(w, o, GMO_INITIALIZE);
  o = (void *)o + GM_FUNCTIONS[*((BYTE *)o) - 1].datasize;

  w->Win.DupScr = OldPlane;
  w->Win.CurAttr = OldAttrs;
  WinFont(&w->Win, OldFont);
  return(o);
}

void GM_DrawStructureGroup(PWINDOW *w, ListElementHeader *g)
{
  int *curobj = (void *)g + 8;
  while(*(curobj))
    curobj = GM_DrawStructureObject(w, curobj);
}

void GM_DrawStructure(PWINDOW *w, ListHeader *list)
{
  ListElementHeader *current;

  if(current = list->start)
    do {
      GM_DrawStructureGroup(w, current);
      current = current->next;
    } while(current != list->start);
}

void GM_InitializeWindow(PWINDOW *w)
{
  HANDLE OldPlane = w->Win.DupScr;
  WIN_RECT Light = {w->Win.Client.xy.x0, w->Win.Client.xy.y0,
                    w->Win.Client.xy.x1, w->Win.Client.xy.y1}; 

  SCR_RECT test1 = {20, 20, 50, 30};
  SCR_RECT test2 = {20, 32, 50, 42};

  w->Win.DupScr = w->ContentsHandle[0];
  WinFill(&w->Win, &Light, A_REVERSE);
  w->Win.DupScr = w->ContentsHandle[1];
  WinFill(&w->Win, &Light, A_NORMAL);

  GM_DrawStructure(w, &w->StructureList);

  w->Win.DupScr = OldPlane;
}

void GM_Click(PWINDOW *w, int dx, int dy)
{
  ListElementHeader *current;

  WM_Click(w, dx, dy);

  if(current = w->StructureList.start)
    do {
      GMO_HEADER *o = (void *)current + 8;
      while((*((int *)o)) && (!MouseInside(w, &o->area)))
        o = (void *)o + GM_FUNCTIONS[*((BYTE *)o) - 1].datasize;

      if(*((int *)o))
        GM_FUNCTIONS[*((BYTE *)o) - 1].function(w, o, GMO_CLICK);

    } while(current != w->StructureList.start);
}
