#define TI92PLUS

#include <romcalls.h>
#include <prosit.h>
#include <winlib.h>
#include <gmlib.h>


// ********************* Constants *********************

MOUSEPOINTER MyMousePointer = {9, 13, 1, 1,
 {{0x8000, 0xc000, 0xa000, 0xb000, 0x9800, 0x8c00, 0x8600, 0x8300,
   0x8180, 0x8700, 0x9c00, 0xb000, 0xc000, 0x0000, 0x0000, 0x0000},
  {0x8000, 0xc000, 0xa000, 0xb000, 0xb800, 0xbc00, 0xbe00, 0xbf00,
  0xbf80, 0xbf00, 0xbc00, 0xb000, 0xc000, 0x0000, 0x0000, 0x0000}},
 {0x8000, 0xc000, 0xe000, 0xf000, 0xf800, 0xfc00, 0xfe00, 0xff00,
  0xff80, 0xff00, 0xfc00, 0xf000, 0xc000, 0x0000, 0x0000, 0x0000}};

WIN_RECT TestWinRect = {10,9,120,99};
WIN_RECT TestWin2Rect = {38,42,150,75};
PWINDOW_DATARETURN WinRet;
char TestWindowTitle[] = "Eric Schwartz Rules!";
char TestWin2Title[] = "Hello, Thinks Mr. Purple Cat";
char Button1Text[] = "Button no. 1";
char Button2Text[] = "Button no. 2";


// *************** Event Implementations ***************
void Event_GMObjectClicked(HANDLE source)
{
  if(WinRet.ButtonID == 2)
    PWinMoveToFront(WinRet.w);
}

// ************* Prosit Header **************
BEGIN_PROSIT_HEADER(_prosit)
  DEFINE_PROSIT_VERSION(PROSIT_VERSION_STRING)
  DEFINE_PROSIT_FILETYPE(PROSIT_FILETYPE_PROGRAM)
  DEFINE_PROSIT_STACKSIZE(0)
  DEFINE_PROSIT_EVENT(GMO_CLICKED_EVENT, Event_GMObjectClicked)
END_PROSIT_HEADER

/*
1000000000000000
1100000000000000
1010000000000000
1001000000000000

1000100000000000
1000010000000000
1000001000000000
1000000100000000

1000000010000000
1000001100000000
1000110000000000
1011000000000000

1100000000000000
0000000000000000
0000000000000000
0000000000000000
*/


BEGIN_GUI_SECTION(aGuiSection)
  ADD_TEXTBUTTON(0,1, 5,20,53,28, Button1Text)
  ADD_TEXTBUTTON(0,2, 57,20,105,28, Button2Text)
END_GUI_SECTION

// ************* Function Implementations **************
void _main(void)
{
  PWINDOW TestWindow, TestWindow2;

  InitWindowSystem(&MyMousePointer);

  ListInitialize(&TestWindow.StructureList);
  ListInsert(&TestWindow.StructureList, &aGuiSection);

  TestWindow.Win.Flags = 0;
  TestWindow.header.flags = 0;
  TestWindow.header.priority = 0;
  PWinOpen(&TestWindow, &TestWinRect, &WinRet, TestWindowTitle);

  ListInitialize(&TestWindow2.StructureList);
  TestWindow2.Win.Flags = 0;
  TestWindow2.header.flags = 0;
  TestWindow2.header.priority = 0;
  PWinOpen(&TestWindow2, &TestWin2Rect, &WinRet, TestWin2Title);

  while(CurrentKey != 264)
    BreakAndCooperate();

  PWinClose(&TestWindow);
  PWinClose(&TestWindow2);
  CloseWindowSystem();
}
