/*****************
* LIST FUNCTIONS *
*****************/

//
// Initialize a list.
//
void ListInitialize(ListHeader *List)
{
  List->start=NULL;
}

//
// Find the list element that preceeds the given one.
//
ListElementHeader *ListPrevious(ListElementHeader *elementheader)
{
  ListElementHeader *Current = elementheader;
  while(Current->next != elementheader)
    Current = Current->next;
  return(Current);
}

//
// Insert a new element into a list.
//
void ListInsert(ListHeader *header, ListElementHeader *elementheader)
{
  if(header->start == NULL) {
    header->start = elementheader;
    elementheader->next = elementheader;
  }
  else {
    ListElementHeader *Current = header->start;

    if(elementheader->priority > Current->priority)
      header->start = elementheader;
    else
      while((elementheader->priority < Current->priority) &&
            ((Current = Current->next) != header->start));

    // Alter list header if new element ended up on top.
    if(Current == header->start)
      header->start = elementheader;

    // Point previous element in list to the new one.
    ListPrevious(Current)->next = elementheader;

    // Point new element to the one it's preceeding.
    elementheader->next = Current;
  }
}

//
// Remove an element from a list.
//
void ListRemove(ListHeader *header, ListElementHeader *elementheader)
{
  if(elementheader->next == elementheader)
    header->start = NULL;
  else {
    ListPrevious(elementheader)->next = elementheader->next;
    if(header->start == elementheader)
      header->start = elementheader->next;
  }
}

//
// Find an element in a list by its ID.
//
ListElementHeader *ListFind(ListHeader *header, WORD idstring)
{
   ListElementHeader *Current = header->start;
   if(Current->id != idstring)
     while(((Current = Current->next) != header->start) && (Current->id != idstring));
   if(Current->id == idstring)
     return(Current);
   else
     return(NULL);
}

//
// Get the size of a list.
//
int ListSize(ListHeader *header)
{
  int size = 0;
  ListElementHeader *Current = header->start;
  if(Current != NULL)
    do {size++;} while((Current = Current->next) != header->start);
  return(size);
}
