/****************
* THE SCHEDULER *
****************/

// The most important piece of code - the scheduler.
PROCESS_CONTEXT_ENTRY *Scheduler(void)
{
  return((PROCESS_CONTEXT_ENTRY *)CurrentProcessContext->header.next);
}

// The Context switch interrupt: save the current process' context, call the
// scheduler to select what process is next to run, restore its context, and
// give it the CPU.
void PreScheduler2(void)
{
  asm("	PreScheduler:
		or.w		#0x0700,%sr
		move.l		%a6,-(%sp)
		move.l		CurrentProcessContext,%a6
		movem.l		%d0-%d7/%a0-%a5,8(%a6)
		move.l		(%sp)+,8+14*4(%a6)
		move.l		%usp,%a1
		move.l		%a1,8+15*4(%a6)
		move.w		(%sp)+,8+16*4(%a6)
		move.l		(%sp)+,8+16*4+2(%a6)
		movem.l		(" XSTR(TIOS_CONSTANTS) "),%a0/%d0-%d7
		movem.l		%a0/%d0-%d7,8+16*4+6(%a6)
		jsr		Scheduler
	PostScheduler:
		move.w		4(%a0)," XSTR(CurrentProcessID) "
		move.l		%a0,CurrentProcessContext
		movem.l		8+16*4+6(%a0),%a1/%d0-%d7
		movem.l		%a1/%d0-%d7,(" XSTR(TIOS_CONSTANTS) ")
		move.l		8+15*4(%a0),%a1
		move.l		%a1,%usp
		move.l		8+16*4+2(%a0),-(%sp)
		move.w		8+16*4(%a0),-(%sp)
		movem.l		8(%a0),%a0-%a6/%d0-%d7
		rte");
}
