;**********************************************************************
;*                             MOUSE CODE                             *
;**********************************************************************
POINTER_HEIGHT		EQU	8
POINTER_WIDTH		EQU	6
POINTER_X_HOTSPOT	EQU	1
POINTER_Y_HOTSPOT	EQU	1
SPEED_DELAY		EQU	3

	EVEN
winlib@0003:
MouseX			dc.w	0
winlib@0004:
MouseY			dc.w	0

Mouse_Interrupt:
	movem.l		a0/d7,-(sp)

;	move.l		WindowInFocus_Return,a0
;	cmp.l		#0,a0
;	beq.s		\nowin
;	move.w		Prosit::CurrentKey,W_DR_KEY(a0)

\nowin	sub.b		#1,mDelay
	bge.s		\done

	move.b		#SPEED_DELAY,mDelay

	move.b		Prosit::ControlKeys,d7

; Mouse code (just update the coordinates)
 ifeq Calculator-TI92Plus
	and.w		#%0000000011110000,d7
	cmp.b		#%11110000,d7
	beq.s		\done		;No key pressed - mouse didn't move
	lsr.b		#2,d7
 endif
 ifeq Calculator-TI89
	and.w		#%0000000000001111,d7
	cmp.b		#%00001111,d7
	beq.s		\done		;No key pressed - mouse didn't move
	lsl.b		#2,d7
 endif
	lea		MouseDirectionData(pc),a0
	move.l		0(a0,d7.w),d7
	add.w		MouseY,d7
	blt.s		\noty
	cmp.w		#SCREEN_HEIGHT-2-POINTER_Y_HOTSPOT,d7
	bgt.s		\noty
	move.w		d7,MouseY
\noty	swap		d7
	add.w		MouseX,d7
	blt.s		\notx
	cmp.w		#SCREEN_WIDTH-POINTER_WIDTH,d7
	bgt.s		\notx
	move.w		d7,MouseX
\notx

\done	movem.l		(sp)+,a0/d7
	move.l		old_int5,-(sp)
	rts

	EVEN

 ifeq Calculator-TI92Plus
MouseDirectionData:
	dc.w	0,0	;Down+Right+Up+Left
	dc.w	0,0	;Down+Right+Up
	dc.w	0,0	;Down+Right+Left
	dc.w	1,1	;Down+Right
	dc.w	0,0	;Down+Right+Left
	dc.w	0,0	;Down+Up
	dc.w	-1,1	;Down+Left
	dc.w	0,1	;Down
	dc.w	0,0	;Right+Up+Left
	dc.w	1,-1	;Right+Up
	dc.w	0,0	;Right+Left
	dc.w	1,0	;Right
	dc.w	-1,-1	;Up+Left
	dc.w	0,-1	;Up
	dc.w	-1,0	;Left
	dc.w	0,0	;No key
 endif

 ifeq Calculator-TI89
MouseDirectionData:
	dc.w	0,0	;Right+Down+Left+Up
	dc.w	0,0	;Right+Down+Left
	dc.w	0,0	;Right+Down+Up
	dc.w	1,1	;Right+Down
	dc.w	0,0	;Right+Left+Up
	dc.w	0,0	;Right+Left
	dc.w	1,-1	;Right+Up
	dc.w	1,0	;Right
	dc.w	0,0	;Down+Left+Up
	dc.w	-1,1	;Down+Left
	dc.w	0,0	;Down+Up
	dc.w	0,1	;Down
	dc.w	-1,-1	;Left+Up
	dc.w	-1,0	;Left
	dc.w	0,-1	;Up
	dc.w	0,0	;No key
 endif

	EVEN


Mouse_Process_Header:
	HEADER_BEGIN
	DEFINE_PROSIT_STACKSIZE	400
	HEADER_END

Mouse_Process:
	clr.b		msout
	move.w		#SCREEN_WIDTH/2,d2
	move.w		#SCREEN_HEIGHT/2,d3
	move.w		d2,MouseX
	move.w		d3,MouseY

Mouse_Plot:
	move.l		#LCD_MEM,a3
	move.w		d3,d4
	lsl.w		#5,d4		;Y*32
	sub.w		d3,d4		;Y*31
	sub.w		d3,d4		;Y*30
	move.w		d2,d5
	lsr.w		#3,d5		;X/8
	add.w		d5,d4
	lea		0(a3,d4.w),a3		;Adress in LCD memory to start plotting at

	move.b		d2,d6
	and.b		#%00000111,d6		;Shift amount

	move.l		#mgfx,a4		;GFX and Mask data
	move.l		#mbuffer,a2		;LCD buffer
	move.l		#mmbuffer,a1		;Shifted mask buffer
	move.l		a3,a5			;Store LCD adress

	move.w		#128-POINTER_HEIGHT,d7
	sub.w		d3,d7
	blt.s		\ok
	moveq		#0,d7
\ok	add.w		#POINTER_HEIGHT-1,d7	;Row counter
	move.w		d7,mRows
\ploop	move.w		(a4)+,d0		;Read Mask data
	ror.w		d6,d0			;Shift Mask data
	move.w		d0,(a1)+		;Store shifted mask data
	move.w		(a4)+,d1		;Read GFX data
	lsr.w		d6,d1			;Shift GFX data
	move.b		(a5),d4			;Read LCD data #1
	lsl.w		#8,d4
	move.b		1(a5),d4		;Read LCD data #2
	move.w		d4,(a2)+		;Store LCD data
	and.w		d0,d4			;Mask LCD data
	or.w		d1,d4			;Add GFX data to LCD data
	move.b		d4,1(a5)		;Plot LCD data #2
	lsr.w		#8,d4
	move.b		d4,(a5)			;Plot LCD data #1
	add.w		#30,a5			;Next row
	dbra.s		d7,\ploop

\noplot	clr.b		msout
	move.w		d2,d0	;Store MouseX
	move.w		d3,d1	;Store MouseY

\check1	BREAK_AND_COOPERATE
	tst.b		msin
	bne.s		\remove

	move.w		MouseX,d2
	move.w		MouseY,d3

	cmp.w		d2,d0
	bne.s		\move
	cmp.w		d3,d1
	beq.s		\check1

\move	bsr		Mouse_Remove
	bra		Mouse_Plot


;"Disable" signalled from winlib.
\remove	move.w		d0,mmx
	move.w		d1,mmy
	move.b		#1,msout
\waitds	BREAK_AND_COOPERATE
	tst.b		msin
	beq.s		\noplot
	bra.s		\waitds

;***********************************************************************

Disable_Mouse:
	move.b		#1,msin	;Signal "disable with saving"
\wait2	BREAK_AND_COOPERATE
	tst.b		msout	;Wait for mouse pointer to signal "waiting"
	beq.s		\wait2
	rts

Enable_Mouse:
	clr.b		msin
\wait2	BREAK_AND_COOPERATE
	tst.b		msout	;Wait for mouse pointer to signal "running"
	bne.s		\wait2
	rts

Mouse_Remove:
	move.l		#mbuffer,a2		;LCD buffer
	move.w		mRows,d7		;Row counter
\rloop	move.b		(a2)+,(a3)
	move.b		(a2)+,1(a3)
	add.w		#30,a3
	dbra.s		d7,\rloop
	rts

;***********************************************************************

	EVEN

mgfx	dc.w	%0001111111111111,%0000000000000000
	dc.w	%0000111111111111,%0100000000000000
	dc.w	%0000011111111111,%0110000000000000
	dc.w	%0000001111111111,%0101000000000000
	dc.w	%0000001111111111,%0100100000000000
	dc.w	%0000001111111111,%0100100000000000
	dc.w	%0000001111111111,%0011100000000000
	dc.w	%1000001111111111,%0000000000000000
