;**********************************************************************
;*                  KEY READER AND MOUSE BUTTON CODE                  *
;**********************************************************************
Mousebutton_Process_Header:
	HEADER_BEGIN
	DEFINE_PROSIT_STACKSIZE	1024
	HEADER_END

Mousebutton_Process:
Mousebutton_Loop:
	BREAK_AND_COOPERATE
	move.l		WindowList,a3
	cmp.l		#0,a3
	beq.s		Mousebutton_Loop			;No windows on screen...
	btst.b		#MOUSEBUTTON,Prosit::ControlKeys
	bne.s		Mousebutton_Loop

;	move.l		WindowList,a4
;	cmp.l		#0,a4
;	beq		Mousebutton_Loop		;List is empty, nothing to remove

	move.l		a3,a1

\loop	move.w		W_X_POS-W_HEADER(a3),d5
	sub.w		#POINTER_X_HOTSPOT,d5

	move.w		MouseX,d2
	sub.w		d5,d2
	blt.s		\next			;Window is right of mousepointer
	cmp.w		W_WIDTH-W_HEADER(a3),d2
	bgt.s		\next			;Window is left of mousepointer
	swap		d5
	move.w		W_Y_POS-W_HEADER(a3),d5
	sub.w		#POINTER_Y_HOTSPOT,d5
	swap		d2
	move.w		MouseY,d2
	sub.w		d5,d2
	blt.s		\next			;Window is below mousepointer
	cmp.w		W_HEIGHT-W_HEADER(a3),d2
	blt.s		\found			;Window is *not* above mousepointer => FOUND!

\next	move.l		W_NEXT-W_HEADER(a3),a3
	cmp.l		a3,a1
	bne.s		\loop

	bra		Mousebutton_Loop


;* FOUND THE WINDOW *
\found	lea		-W_HEADER(a3),a3

	btst.b		#WFB_LOCKED,W_FLAGS(a3)
	bne		GUI_Outside_NoArea	;Window is locked, do nothing!

	move.l		a3,-(sp)
	bsr		Move_Window_To_Front
	addq.l		#4,sp

	move.l		WindowInFocus_Return,a6
	cmp.l		#0,a6
	beq		GUI_Outside_NoArea	;Window has no datareturn area
	move.w		WindowInFocus,W_DR_MOUSE_WINDOW(a6)	;Window
	move.l		W_STRUCTURE(a3),a1	;*Structure pointers
	clr.w		W_DR_MOUSE_BUTTON(a6)	;Default return value is zero
	cmp.l		#0,a1
	beq		GUI_Outside_Area	;Window has no structure, click goes to window

;****************************
;*                          *
;* DEAL WITH THE WINDOW GUI *
;*                          *
;****************************
	move.w		#2,GUI_ManPart_Counter
GUI_Next_List:
	move.l		(a1)+,a0		;Next management part (GUI / Got focus / Lost focus)
	cmp.l		#0,a0
	beq		GUI_Get_Next_List	;Management part isn't used, go to next one.

	move.l		a0,a5		;Store pointer to first item in list

GUI_Next_List_Item:
	lea		LIST_HEADER_SIZE+4(a0),a2	;*Management part

GUI_Loop:
	move.l		(a2)+,a4	;*Item data
	move.w		(a2)+,d1	;Return value for item
	cmp.l		#0,a4
	beq		GUI_Get_Next_List_Item	;No item in the clicked area.

	moveq		#0,d6
	move.b		2(a4),d6		;X1
	swap		d6
	cmp.l		d6,d2
	blt.s		GUI_Loop		;X < X1
	move.b		3(a4),d6		;Y1
	cmp.w		d6,d2
	blt.s		GUI_Loop		;Y < Y1

	moveq		#0,d7
	move.b		4(a4),d7		;X2
	swap		d7
	move.w		d2,d7

	cmp.l		d7,d2
	bgt.s		GUI_Loop		;X > X2
	move.b		5(a4),d7		;Y2
	cmp.w		d7,d2
	bgt.s		GUI_Loop		;Y > Y2

;Found the correct click area, now deal with it!
GUI_Handler:
	cmp.w		#-1,d1
	beq		GUI_Drag_Window		;System value: drag window

	move.w		d1,W_DR_MOUSE_BUTTON(a6)		;Return value
	and.w		#%0000011111111111,W_DR_MOUSE_BUTTON(a6)

	moveq		#0,d3
	move.b		(a4),d3			;Item ID
	beq		GUI_Outside_Area	;ID=0 => "drawing" area

;	HexShow		a4,#0,#10,#7

;* FOUND AN OBJECT THAT NEEDS TO BE AFFECTED - SET PORT REGION *
	move.l		a3,-(sp)
	bsr		WinSelect
	addq.l		#4,sp

;* NOW DEAL WITH OBJECT *
	move.l		#"moub",-(sp)		;Event
	btst.w		#11,d1
	beq.s		\okev
	move.l		#"quit",(sp)		;Event
\okev	move.w		W_OWNER(a3),-(sp)	;Window owner process

	subq.w		#1,d3			;"Area" is no. 0...
	lsl.w		#2,d3
	lea		GUI_Locations(pc),a6
	move.l		0(a6,d3.w),a6		;*Object handler code

	move.l		d5,\ghsmc0+2		;Store some constants using SMC
	move.l		#$FFFFFFFF,\ghsmc1+2	;Reset "last mouse position"

	move.w		d1,d5
	move.b		#%01000100,d5		;First click + "inside"
	swap		d5
	addq.l		#6,a4
	move.w		(a4)+,d5		;Flags

	btst.l		#30,d5
	beq.s		\nofrep
	bset.l		#17,d5			;Uses repeat calls

\nofrep	jsr		(a6)			;Initialize object
	add.l		Prosit::Ticks,d4	;For repeat calls

	btst.l		#31,d5			;Trigger event on first click?
	beq.s		\main			;No
\trig	jsr		Prosit::Trigger_Event	;Yes

\main	BREAK_AND_COOPERATE
	btst.b		#MOUSEBUTTON,Prosit::ControlKeys
	bne		\relese			;Mousebutton released!

	and.l		#%11111111000001001111111111111111,d5	;Clear all signal bits

	btst.l		#30,d5
	beq.s		\norep			;No repeat calls

	cmp.l		Prosit::Ticks,d4
	bgt.s		\norep			;Delay hasn't expired yet, wait some more
	bset.l		#17,d5			;Signal "repeat call"
	jsr		(a6)			;Something has happened, tell object.
	add.l		Prosit::Ticks,d4
	btst.l		#16,d5		;Force-trig?
	bne.s		\dtrig		;Yes, trig anyway!
	btst.l		#18,d5		;Inside?
	beq.s		\norep		;No, don't trigger event
	btst.l		#29,d5		;Trigger event on repeat call?
	beq.s		\norep
\dtrig	jsr		Prosit::Trigger_Event	;Yes

;Get relative X/Y-coordinates:
\norep	move.w		MouseX,d3		;Mouse Y position
	swap		d3
	move.w		MouseY,d3		;Mouse X position
\ghsmc0	sub.l		#$12345678,d3		;Adjust for pointer hotspot and make relative to window position
\ghsmc1	cmp.l		#$12345678,d3		;Has mousepointer moved?
	beq.s		\main			;No, keep waiting
	move.l		d3,\ghsmc1+2		;Yes, copy new position...
	bset.l		#20,d5			;...and set the bit to signal movement.
;Check boundaries:
	cmp.l		d6,d3
	blt.s		\out		;X < X1
	cmp.w		d6,d3
	blt.s		\out		;Y < Y1
	cmp.l		d7,d3
	bgt.s		\out		;X > X2
	cmp.w		d7,d3
	bgt.s		\out		;Y > Y2
;	sub.l		d6,d3
;We're inside, set bit and redraw if necessary
	bset.l		#18,d5
	bne		\nochg	;Bit didn't change, don't redraw
	bset.l		#19,d5
	bra		\nochg	;Bit changed, redraw
;We're outside, clear bit and redraw if necessary
\out
	bclr.l		#18,d5
	beq		\nochg	;Bit didn't change, don't redraw
	bset.l		#19,d5	;Bit changed, redraw

\nochg	jsr		(a6)		;Signal object that something has happened
	btst.l		#16,d5		;Force-trig?
	bne		\trig		;Yes, trig anyway!
	bra		\main		;No, loop!

;Mousebutton released, signal object!
\relese	and.l		#%11111111000001001111111111111111,d5
	or.l		#%00000000001000000000000000000000,d5
	jsr		(a6)		;Tell object that mousebutton has been released

	btst.l		#18,d5
	beq.s		\done			;We where outside when it was released, don't trigger!
	btst.l		#28,d5			;Trigger event on release?
	beq.s		\done			;No
	jsr		Prosit::Trigger_Event	;Yes
\done	addq.l		#6,sp
	bra		Mousebutton_Loop





	include		"guilib.asm"

;******************************
;* JUMP TABLE FOR GUI OBJECTS *
;******************************
	EVEN
GUI_Locations:
	dc.l		guilib__Button
	dc.l		guilib__Horiz_Slider
	dc.l		guilib__Vert_Slider
	dc.l		guilib__Text
	dc.l		guilib__Line
	dc.l		guilib__Rect
	dc.l		guilib__Fill
	dc.l		guilib__SetClip

;*****************************
;* Get next item in GUI list *
;*****************************
GUI_Get_Next_List_Item:
	move.l		(a0),a0
	cmp.l		a0,a5
	bne		GUI_Next_List_Item	;More items in this list
GUI_Get_Next_List:
	sub.w		#1,GUI_ManPart_Counter
	bne		GUI_Next_List		;More lists exist

;*************************************************************
;* No area was clicked, wait for mousebutton to be released. *
;*************************************************************
GUI_Outside_NoArea:
	BREAK_AND_COOPERATE
	btst.b		#MOUSEBUTTON,Prosit::ControlKeys
	beq.s		GUI_Outside_NoArea
	bra		Mousebutton_Loop

;*************************************************************
;* Area with return value zero where clicked, keep updating  *
;* relative MouseX and MouseY until mousebutton is released. *
;*************************************************************
GUI_Outside_Area:
;	move.w		WindowInFocus,-(sp)
;	bsr		Refresh_Window
;	addq.l		#2,sp
	TRIGGER_EVENT	W_OWNER(a4),#"moub"		;Trigger Mousebutton event
\relese	move.w		MouseX,d2
	add.w		#POINTER_X_HOTSPOT,d2
	sub.w		W_X_POS(a4),d2
	move.w		MouseY,d3
	add.w		#POINTER_Y_HOTSPOT,d3
	sub.w		W_Y_POS(a4),d3
	move.w		d2,W_DR_MOUSE_X(a6)
	move.w		d3,W_DR_MOUSE_Y(a6)
	btst.b		#MOUSEBUTTON,Prosit::ControlKeys
	beq.s		\relese
;	tst.w		W_DR_MOUSE_BUTTON(a6)
;	bne.s		\relese
\waitmb	btst.b		#MOUSEBUTTON,Prosit::ControlKeys
	beq.s		\waitmb
	clr.w		W_DR_MOUSE_BUTTON(a6)
	bra		Mousebutton_Loop

;*******************
;* DRAG THE WINDOW *
;*******************
GUI_Drag_Window:
	add.l		#POINTER_X_HOTSPOT*65536+POINTER_Y_HOTSPOT,d5
	sub.l		#POINTER_X_HOTSPOT*65536+POINTER_Y_HOTSPOT,d2
	move.l		d2,d7	;d2.w = Y
	swap		d7	;d7.w = X

	subq.l		#8,sp			;Prepare the stack
	move.l		WindowInFocus,(sp)	;Window ID

\holdl	BREAK_AND_COOPERATE
	btst.b		#MOUSEBUTTON,Prosit::ControlKeys
	bne.s		\done			;Mousebutton was released

	move.w		MouseX,d1		;d0 = X
	sub.w		d7,d1
	swap		d1
	move.w		MouseY,d1		;d1 = Y
	sub.w		d2,d1

	cmp.l		d1,d5			;Has the mousepointer moved?
	beq.s		\holdl			;No, loop
	move.l		d1,d5

	move.l		d1,4(sp)
	bsr		Move_Window
	bra.s		\holdl

\done	addq.l		#8,sp
	bra		Mousebutton_Loop






;---------------------------------------------------------------------
; DrawStructure(WINDOW *w, WIN_STRUCTLIST *list)
;
; Function: Draw an entire structure list into window.
;---------------------------------------------------------------------
DrawStructure:
winlib@0015:
	movem.l		a0-a1,-(sp)

	move.l		4+2*4+4(sp),a0		;*structure
	move.l		a0,a1			;Store pointer to first item in list
	subq.l		#8,sp			;Make room for *item
	move.l		8+4+2*4(sp),(sp)	;*Window
\loop	move.l		a0,4(sp)		;Put *item on stack
	bsr		DrawStructureItem	;Draw item
	move.l		(a0),a0			;Get pointer to next item
	cmp.l		a0,a1			;Is it the first item in the list?
	bne.s		\loop			;No, loop.

	addq.l		#8,sp			;Restore stack
	movem.l		(sp)+,a0-a1
	rts

;---------------------------------------------------------------------
; DrawStructureItem(WINDOW *w, WIN_STRUCTITEM *item)
;
; Function: Draw the <item> part of the structure list from into
;  window.
;---------------------------------------------------------------------
DrawStructureItem:
winlib@0016:
	movem.l		a0,-(sp)

	move.l		4+1*4+4(sp),a0		;*structure
	move.l		LIST_HEADER_SIZE(a0),a0	;*Graphical part

	cmp.l		#0,a0
	beq.s		\done
	subq.l		#8,sp			;Make room for *item
	move.l		8+4+1*4(sp),(sp)	;*Window

\loop	tst.b		(a0)			;Object = -1 ?
	blt.s		\nomore			;Yes, we're done.
	move.l		a0,4(sp)
	bsr		DrawStructureObject
	bra.s		\loop
\nomore	addq.l		#8,sp			;Restore stack

\done	movem.l		(sp)+,a0
	rts

;---------------------------------------------------------------------
; DrawStructureObject(WINDOW *w, WIN_STRUCTOBJECT *object)
;
; Function: Draw <object> into window.
;
; Output: a0 = *next object
;---------------------------------------------------------------------
DrawStructureObject:
winlib@0017:
	movem.l		a1-a6/d0-d7,-(sp)

	move.l		4+14*4(sp),a3		;Get *window
	move.l		4+14*4+4(sp),a4		;Get *object

	moveq		#0,d6
	move.b		(a4)+,d6
	subq.w		#1,d6			;"Area" is no. 0...
	lsl.w		#2,d6
	lea		GUI_Locations(pc),a5
	move.l		0(a5,d6.w),a5		;*Object handler code

	addq.l		#1,a4		;Skip flags for now

	moveq		#0,d6
	moveq		#0,d7
	move.b		(a4)+,d6	;X
	swap		d6
	move.b		(a4)+,d6	;Y
	move.b		(a4)+,d7	;Width
	swap		d7
	move.b		(a4)+,d7	;Height

	move.l		#$00800000,d5	;Initialize
	move.w		(a4)+,d5	;Put object flags into d0.uw
	jsr		(a5)		;Initialize object
	move.l		a5,a0

	movem.l		(sp)+,a1-a6/d0-d7
	rts
