#define TI92PLUS

#include <romcalls.h>
#include <prosit.h>
#include <winlib.h>
#include <wmlib.h>

int _library;

void WM_InitializeWindow(PWINDOW *w)
{
  if(!(w->Win.Flags & WF_NOBORDER)) {
    WIN_RECT Light = {0, 0, w->Width-1, w->Height - 1};
    WIN_RECT Dark1 = {1, 8, w->Width-1, w->Height - 1};
    WIN_RECT Dark2 = {w->Width-1, 1, w->Width-1, 8};
    HANDLE OldPlane = w->Win.DupScr;
    int i;

    // Set the window region to what the WM has access to, and set the clip
    // region to the same temporarily so that we can draw something there :)
    w->Win.Clip = w->Win.Window = (SCR_RECT){0, 0, w->Width-1, w->Height - 1};

    // Draw some stuff
    for(i=1 ; i>=0 ; i--) {
      w->Win.DupScr = w->ContentsHandle[i];
      WinRect(&w->Win, &Light, A_REVERSE+B_DOUBLE);
      WinRect(&w->Win, &Dark1, A_NORMAL);
      WinLine(&w->Win, &Dark2);
      if(w->Win.Title) {
        BYTE OldFont = w->Win.CurFont;
        BYTE OldAttr = WinAttr(&w->Win, A_NORMAL);
        WinFont(&w->Win, 0);
        WinStrXY(&w->Win, 1, 2, w->Win.Title);
        WinFont(&w->Win, OldFont);
        WinAttr(&w->Win, OldAttr);
      }
    }

    // Show that the window doesn't have focus.
    Light = (WIN_RECT){1, 1, w->Width-2, 7};
    WinFill(&w->Win, &Light, A_XOR);

    // Set the client and clip areas.
    w->Win.Clip = w->Win.Client = (SCR_RECT){2, 9, w->Width-3, w->Height - 3};

    w->Win.DupScr = OldPlane;
  }
}

void WM_WindowGotFocus(PWINDOW *w)
{
  if(!(w->Win.Flags & WF_NOBORDER)) {
    HANDLE OldPlane = w->Win.DupScr;
    SCR_RECT OldClip = w->Win.Clip;
    WIN_RECT Light = {1, 1, w->Width-2, 7};

    // Set the clip region to the WM region so that we can draw.
    w->Win.Clip = w->Win.Window;

    // Toggle the "title bar".
    w->Win.DupScr = w->ContentsHandle[1];
    WinFill(&w->Win, &Light, A_XOR);

    PWinRefresh(w);

    // Restore what we have changed.
    w->Win.Clip = OldClip;
    w->Win.DupScr = OldPlane;
  }
}

void WM_WindowLostFocus(PWINDOW *w)
{
  WM_WindowGotFocus(w);
}

void WM_Click(PWINDOW *w, int dx, int dy)
{
  if(WindowInFocus != w) {
    WM_WindowLostFocus(WindowInFocus);
    TriggerEvent(WindowInFocus->Win.TaskId, LOST_FOCUS_EVENT);

    WM_WindowGotFocus(w);
    TriggerEvent(w->Win.TaskId, GOT_FOCUS_EVENT);

    WindowInFocus = w;
  }

  if(dy < 10) {
    int OldMouseX = MouseX, OldMouseY = MouseY;
    PWinMoveToFront(w);
    while(!MOUSEKEY) {
      if((MouseX != OldMouseX) || (MouseY != OldMouseY)) {
        OldMouseX = MouseX;
        OldMouseY = MouseY;
        PWinMoveTo(w, MouseX-dx, MouseY-dy);
      }
      BreakAndCooperate();
    }
  }
}
